import json
from abc import ABC


class ChanObject(ABC):
    def __init__(self, data_dict=None):
        self.data = {}

        if data_dict is not None:
            self.load_json(json.dumps(data_dict))

    def load_json(self, json_string):
        self.data = json.loads(json_string)

    def to_json_string(self):
        return json.dumps(self.data)

    def __getattr__(self, key):
        return self.data[key]

    def __setattr__(self, key, value):
        if key == 'data':
            super().__setattr__(key, value)
        else:
            self.data[key] = value

    def __delattr__(self, key):
        del self.data[key]

    def __repr__(self):
        return self.to_json_string()


class Thread(ChanObject):
    def __init__(self, data_dict=None):
        super().__init__(data_dict)


class Post(ChanObject):
    def __init__(self, data_dict=None):
        super().__init__(data_dict)


class Board(ChanObject):
    def __init__(self, data_dict=None):
        super().__init__(data_dict)
